package com.bomostory.sceneeditmodule.navigationbar.brush

import android.content.Context
import android.support.v4.content.ContextCompat
import android.util.AttributeSet
import android.view.LayoutInflater
import android.widget.LinearLayout
import android.widget.SeekBar
import com.example.tfat.myapplication.R
import kotlinx.android.synthetic.main.scene_brush_view.view.*

class BrushView : LinearLayout {
    constructor(context: Context) : super(context) {
        initView()
    }

    constructor(context: Context, attrs: AttributeSet) : super(context, attrs) {
        initView()
    }

    constructor(context: Context, attrs: AttributeSet, defStyle: Int) : super(context, attrs, defStyle) {
        initView()
    }

    private fun initView() {
        LayoutInflater.from(context).inflate(R.layout.scene_brush_view, this, true)
        iv_brush_view_color1.setOnClickListener {
            initColorState()
            iv_brush_view_color1.background = ContextCompat.getDrawable(context, R.drawable.btn_edit_text_dialog_circle_selected)
        }
        iv_brush_view_color2.setOnClickListener {
            initColorState()
            iv_brush_view_color2.background = ContextCompat.getDrawable(context, R.drawable.btn_edit_text_dialog_circle_selected)
        }
        iv_brush_view_color3.setOnClickListener {
            initColorState()
            iv_brush_view_color3.background = ContextCompat.getDrawable(context, R.drawable.btn_edit_text_dialog_circle_selected)
        }
        iv_brush_view_color4.setOnClickListener {
            initColorState()
            iv_brush_view_color4.background = ContextCompat.getDrawable(context, R.drawable.btn_edit_text_dialog_circle_selected)
        }
        iv_brush_view_color5.setOnClickListener {
            initColorState()
            iv_brush_view_color5.background = ContextCompat.getDrawable(context, R.drawable.btn_edit_text_dialog_circle_selected)
        }
        iv_brush_view_color6.setOnClickListener {
            initColorState()
            iv_brush_view_color6.background = ContextCompat.getDrawable(context, R.drawable.btn_edit_text_dialog_circle_selected)
        }
        iv_brush_view_color7.setOnClickListener {
            initColorState()
            iv_brush_view_color7.background = ContextCompat.getDrawable(context, R.drawable.btn_edit_text_dialog_circle_selected)
        }
        iv_brush_view_color8.setOnClickListener {
            initColorState()
            iv_brush_view_color8.background = ContextCompat.getDrawable(context, R.drawable.btn_edit_text_dialog_circle_selected)
        }
        iv_brush_view_color9.setOnClickListener {
            initColorState()
            iv_brush_view_color9.background = ContextCompat.getDrawable(context, R.drawable.btn_edit_text_dialog_circle_selected)
        }
        iv_brush_view_color10.setOnClickListener {
            initColorState()
            iv_brush_view_color10.background = ContextCompat.getDrawable(context, R.drawable.btn_edit_text_dialog_circle_selected)
        }
        iv_brush_view_brush1.setOnClickListener {
            initBrushState()
            iv_brush_view_brush1.alpha = 1f
        }
        iv_brush_view_brush2.setOnClickListener {
            initBrushState()
            iv_brush_view_brush2.alpha = 1f
        }
        iv_brush_view_brush3.setOnClickListener {
            initBrushState()
            iv_brush_view_brush3.alpha = 1f
        }
        iv_brush_view_brush4.setOnClickListener {
            initBrushState()
            iv_brush_view_brush4.alpha = 1f
        }
        iv_brush_view_brush5.setOnClickListener {
            initBrushState()
            iv_brush_view_brush5.alpha = 1f
        }
    }

    fun setBrushSize(size: Int, onSeekBarChangeListener: SeekBar.OnSeekBarChangeListener){
        tv_brush_view_size.text = "Size: " + size.toString() + "px"
        seek_bar_brush_view_size.progress = size
        seek_bar_brush_view_size.setOnSeekBarChangeListener(onSeekBarChangeListener)
    }

    fun setOnDoneClick(onClickListener: OnClickListener){
        btn_brush_view_done.setOnClickListener(onClickListener)
    }

    fun getBrushSize() : Int{
        return seek_bar_brush_view_size.progress
    }

    private fun initColorState(){
        iv_brush_view_color1.background = null
        iv_brush_view_color2.background = null
        iv_brush_view_color3.background = null
        iv_brush_view_color4.background = null
        iv_brush_view_color5.background = null
        iv_brush_view_color6.background = null
        iv_brush_view_color7.background = null
        iv_brush_view_color8.background = null
        iv_brush_view_color9.background = null
        iv_brush_view_color10.background = null
    }

    private fun initBrushState(){
        iv_brush_view_brush1.alpha = 0.7f
        iv_brush_view_brush2.alpha = 0.7f
        iv_brush_view_brush3.alpha = 0.7f
        iv_brush_view_brush4.alpha = 0.7f
        iv_brush_view_brush5.alpha = 0.7f
    }
}